#include "client.h"

#include <TelepathyQt4/ChannelClassSpec>
#include <TelepathyQt4/IncomingFileTransferChannel>


FileTransferClient::FileTransferClient()
    : Tp::AbstractClientHandler(
          Tp::ChannelClassSpec(TP_QT4_IFACE_CHANNEL_TYPE_FILE_TRANSFER,
                               Tp::HandleTypeContact, false))
{
}

bool
FileTransferClient::bypassApproval() const
{
    // Return false if a separate approver is supposed to exist
    // for channels handled by this client
    return true;
}

void
FileTransferClient::handleChannels(
        const Tp::MethodInvocationContextPtr<> &context,
        const Tp::AccountPtr &account,
        const Tp::ConnectionPtr &connection,
        const QList<Tp::ChannelPtr> &channels,
        const QList<Tp::ChannelRequestPtr> &requestsSatisfied,
        const QDateTime &userActionTime,
        const Tp::AbstractClientHandler::HandlerInfo &handlerInfo)
{
    foreach (const Tp::ChannelPtr &channel, channels) {
        if (channel->channelType() != TP_QT4_IFACE_CHANNEL_TYPE_FILE_TRANSFER) {
            continue;
        }

        Tp::IncomingFileTransferChannelPtr fileTranferChannel =
                Tp::IncomingFileTransferChannelPtr::staticCast(channel);

        // TODO: accept
    }

    context->setFinished();
}
