#ifndef TELEPATHY_FT_DEMO_MAINWINDOW_H
#define TELEPATHY_FT_DEMO_MAINWINDOW_H

#include <QtGui/QMainWindow>
#include <TelepathyQt4/AccountManager>
#include <TelepathyQt4/AccountSet>
#include <TelepathyQt4/ClientRegistrar>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    virtual ~MainWindow();

private Q_SLOTS:
    void onAccountManagerReady(Tp::PendingOperation *op);
    void onAccountAdded(const Tp::AccountPtr &account);
    void onAccountRemoved(const Tp::AccountPtr &account);

    void on_fileBrowseButton_clicked();

    void on_sendButton_clicked();

private:
    Ui::MainWindow *ui;

    Tp::AccountManagerPtr accountManager;

    // The filtered set of accounts usable for file transfer
    Tp::AccountSetPtr accountSet;

    Tp::ClientRegistrarPtr clientRegistrar;
};

#endif // TELEPATHY_FT_DEMO_MAINWINDOW_H
