#ifndef TELEPATHY_FT_DEMO_SENDDIALOG_H
#define TELEPATHY_FT_DEMO_SENDDIALOG_H

#include <QProgressDialog>
#include <QIODevice>
#include <QPointer>

#include <TelepathyQt4/ChannelRequest>
#include <TelepathyQt4/OutgoingFileTransferChannel>

namespace Tp {
    class PendingChannelRequest;
    class PendingOperation;
}


class SendDialog : public QProgressDialog
{
    Q_OBJECT
public:
    explicit SendDialog(QWidget *parent = 0);

    void setPendingChannelRequest(Tp::PendingChannelRequest *pendingOp);
    void setFile(QIODevice *in);

signals:

private slots:
    void onPendingChannelRequestFinished(Tp::PendingOperation*);
    void onChannelRequestCreated(Tp::ChannelRequestPtr request);
    void onChannelRequestSucceeded(const Tp::ChannelPtr &sendChannel);
    void onChannelRequestFailed(const QString &errorName,
                                const QString& errorMessage);
    void onTransferStateChanged(Tp::FileTransferState state,
                                Tp::FileTransferStateChangeReason reason);
    void onInitialOffsetDefined(qulonglong count);
    void onTransferredBytesChanged(qulonglong count);

private:

    int scaleFileOffset(qulonglong off)
    {
        return int(off >> fileOffsetShift);
    }

    void updateTransferStateMessage(Tp::FileTransferState state,
                                    Tp::FileTransferStateChangeReason reason = Tp::FileTransferStateChangeReasonNone);

    Tp::ChannelRequestPtr channelRequest;
    Tp::OutgoingFileTransferChannelPtr sendChannel;
    QPointer<QIODevice> file;
    unsigned int fileOffsetShift;
};

#endif // TELEPATHY_FT_DEMO_SENDDIALOG_H
